--- old/usr/src/uts/common/inet/tcp/tcp.c	Mon Jul 29 18:04:21 2013
+++ new/usr/src/uts/common/inet/tcp/tcp.c	Mon Jul 29 18:04:21 2013
@@ -23,6 +23,7 @@
  * Copyright (c) 1991, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright (c) 2011, Joyent Inc. All rights reserved.
  * Copyright (c) 2011 Nexenta Systems, Inc. All rights reserved.
+ * Copyright (c) 2013 by Delphix. All rights reserved.
  */
 /* Copyright (c) 1990 Mentat Inc. */
 
@@ -232,11 +233,6 @@
  */
 uint_t tcp_free_list_max_cnt = 0;
 
-#define	TCP_XMIT_LOWATER	4096
-#define	TCP_XMIT_HIWATER	49152
-#define	TCP_RECV_LOWATER	2048
-#define	TCP_RECV_HIWATER	128000
-
 #define	TIDUSZ	4096	/* transport interface data unit size */
 
 /*
@@ -2718,7 +2714,12 @@
 
 	connp->conn_rcvbuf = tcps->tcps_recv_hiwat;
 	connp->conn_sndbuf = tcps->tcps_xmit_hiwat;
-	connp->conn_sndlowat = tcps->tcps_xmit_lowat;
+	if (tcps->tcps_snd_lowat_fraction != 0) {
+		connp->conn_sndlowat = connp->conn_sndbuf /
+		    tcps->tcps_snd_lowat_fraction;
+	} else {
+		connp->conn_sndlowat = tcps->tcps_xmit_lowat;
+	}
 	connp->conn_so_type = SOCK_STREAM;
 	connp->conn_wroff = connp->conn_ht_iphc_allocated +
 	    tcps->tcps_wroff_xtra;
